# autogenerated by genmsg_py from GetChompCollisionCostRequest.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg
import roslib.msg
import roslib.rostime
import motion_planning_msgs.msg
import sensor_msgs.msg

class GetChompCollisionCostRequest(roslib.message.Message):
  _md5sum = "00fbc83b8c2718fd60b487da44ea52bd"
  _type = "chomp_motion_planner/GetChompCollisionCostRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """
string[] links



motion_planning_msgs/RobotState state


================================================================================
MSG: motion_planning_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state
motion_planning_msgs/MultiDOFJointState multi_dof_joint_state
================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint is defined by:
#  * the position of the joint, 
#  * the velocity of the joint and 
#  * the effort that is applied in the joint.
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: motion_planning_msgs/MultiDOFJointState
#A representation of a multi-dof joint state
time stamp
string joint_name
string frame_id
string child_frame_id
geometry_msgs/Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['links','state']
  _slot_types = ['string[]','motion_planning_msgs/RobotState']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   links,state
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(GetChompCollisionCostRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.links is None:
        self.links = []
      if self.state is None:
        self.state = motion_planning_msgs.msg.RobotState()
    else:
      self.links = []
      self.state = motion_planning_msgs.msg.RobotState()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      #serialize self.links
      length = len(self.links)
      buff.write(struct.pack('<I', length))
      for val1 in self.links:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      buff.write(struct.pack('<3I', self.state.joint_state.header.seq, self.state.joint_state.header.stamp.secs, self.state.joint_state.header.stamp.nsecs))
      length = len(self.state.joint_state.header.frame_id)
      #serialize self.state.joint_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.state.joint_state.header.frame_id))
      #serialize self.state.joint_state.name
      length = len(self.state.joint_state.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.state.joint_state.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.state.joint_state.position
      length = len(self.state.joint_state.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.state.joint_state.position))
      #serialize self.state.joint_state.velocity
      length = len(self.state.joint_state.velocity)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.state.joint_state.velocity))
      #serialize self.state.joint_state.effort
      length = len(self.state.joint_state.effort)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.state.joint_state.effort))
      buff.write(struct.pack('<2I', self.state.multi_dof_joint_state.stamp.secs, self.state.multi_dof_joint_state.stamp.nsecs))
      length = len(self.state.multi_dof_joint_state.joint_name)
      #serialize self.state.multi_dof_joint_state.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.state.multi_dof_joint_state.joint_name))
      length = len(self.state.multi_dof_joint_state.frame_id)
      #serialize self.state.multi_dof_joint_state.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.state.multi_dof_joint_state.frame_id))
      length = len(self.state.multi_dof_joint_state.child_frame_id)
      #serialize self.state.multi_dof_joint_state.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.state.multi_dof_joint_state.child_frame_id))
      buff.write(struct.pack('<7d', self.state.multi_dof_joint_state.pose.position.x, self.state.multi_dof_joint_state.pose.position.y, self.state.multi_dof_joint_state.pose.position.z, self.state.multi_dof_joint_state.pose.orientation.x, self.state.multi_dof_joint_state.pose.orientation.y, self.state.multi_dof_joint_state.pose.orientation.z, self.state.multi_dof_joint_state.pose.orientation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.state is None:
        self.state = motion_planning_msgs.msg.RobotState()
      end = 0
      #deserialize self.links
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.links = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.links.append(val1)
      start = end
      end += 12
      (self.state.joint_state.header.seq, self.state.joint_state.header.stamp.secs, self.state.joint_state.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.state.joint_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.state.joint_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.state.joint_state.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.state.joint_state.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.state.joint_state.name.append(val1)
      #deserialize self.state.joint_state.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.state.joint_state.position = struct.unpack(pattern, str[start:end])
      #deserialize self.state.joint_state.velocity
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.state.joint_state.velocity = struct.unpack(pattern, str[start:end])
      #deserialize self.state.joint_state.effort
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.state.joint_state.effort = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.state.multi_dof_joint_state.stamp.secs, self.state.multi_dof_joint_state.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.state.multi_dof_joint_state.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.state.multi_dof_joint_state.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.state.multi_dof_joint_state.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.state.multi_dof_joint_state.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.state.multi_dof_joint_state.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.state.multi_dof_joint_state.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.state.multi_dof_joint_state.pose.position.x, self.state.multi_dof_joint_state.pose.position.y, self.state.multi_dof_joint_state.pose.position.z, self.state.multi_dof_joint_state.pose.orientation.x, self.state.multi_dof_joint_state.pose.orientation.y, self.state.multi_dof_joint_state.pose.orientation.z, self.state.multi_dof_joint_state.pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      #serialize self.links
      length = len(self.links)
      buff.write(struct.pack('<I', length))
      for val1 in self.links:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      buff.write(struct.pack('<3I', self.state.joint_state.header.seq, self.state.joint_state.header.stamp.secs, self.state.joint_state.header.stamp.nsecs))
      length = len(self.state.joint_state.header.frame_id)
      #serialize self.state.joint_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.state.joint_state.header.frame_id))
      #serialize self.state.joint_state.name
      length = len(self.state.joint_state.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.state.joint_state.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.state.joint_state.position
      length = len(self.state.joint_state.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.state.joint_state.position.tostring())
      #serialize self.state.joint_state.velocity
      length = len(self.state.joint_state.velocity)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.state.joint_state.velocity.tostring())
      #serialize self.state.joint_state.effort
      length = len(self.state.joint_state.effort)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.state.joint_state.effort.tostring())
      buff.write(struct.pack('<2I', self.state.multi_dof_joint_state.stamp.secs, self.state.multi_dof_joint_state.stamp.nsecs))
      length = len(self.state.multi_dof_joint_state.joint_name)
      #serialize self.state.multi_dof_joint_state.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.state.multi_dof_joint_state.joint_name))
      length = len(self.state.multi_dof_joint_state.frame_id)
      #serialize self.state.multi_dof_joint_state.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.state.multi_dof_joint_state.frame_id))
      length = len(self.state.multi_dof_joint_state.child_frame_id)
      #serialize self.state.multi_dof_joint_state.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.state.multi_dof_joint_state.child_frame_id))
      buff.write(struct.pack('<7d', self.state.multi_dof_joint_state.pose.position.x, self.state.multi_dof_joint_state.pose.position.y, self.state.multi_dof_joint_state.pose.position.z, self.state.multi_dof_joint_state.pose.orientation.x, self.state.multi_dof_joint_state.pose.orientation.y, self.state.multi_dof_joint_state.pose.orientation.z, self.state.multi_dof_joint_state.pose.orientation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.state is None:
        self.state = motion_planning_msgs.msg.RobotState()
      end = 0
      #deserialize self.links
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.links = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.links.append(val1)
      start = end
      end += 12
      (self.state.joint_state.header.seq, self.state.joint_state.header.stamp.secs, self.state.joint_state.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.state.joint_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.state.joint_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.state.joint_state.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.state.joint_state.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.state.joint_state.name.append(val1)
      #deserialize self.state.joint_state.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.state.joint_state.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.state.joint_state.velocity
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.state.joint_state.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.state.joint_state.effort
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.state.joint_state.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 8
      (self.state.multi_dof_joint_state.stamp.secs, self.state.multi_dof_joint_state.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.state.multi_dof_joint_state.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.state.multi_dof_joint_state.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.state.multi_dof_joint_state.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.state.multi_dof_joint_state.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.state.multi_dof_joint_state.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.state.multi_dof_joint_state.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.state.multi_dof_joint_state.pose.position.x, self.state.multi_dof_joint_state.pose.position.y, self.state.multi_dof_joint_state.pose.position.z, self.state.multi_dof_joint_state.pose.orientation.x, self.state.multi_dof_joint_state.pose.orientation.y, self.state.multi_dof_joint_state.pose.orientation.z, self.state.multi_dof_joint_state.pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

# autogenerated by genmsg_py from GetChompCollisionCostResponse.msg. Do not edit.
import roslib.message
import struct

import chomp_motion_planner.msg

class GetChompCollisionCostResponse(roslib.message.Message):
  _md5sum = "bed009b7d4d6620621ef40430dbc9236"
  _type = "chomp_motion_planner/GetChompCollisionCostResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """

float64[] costs




JointVelocityArray[] gradient


uint8 in_collision


================================================================================
MSG: chomp_motion_planner/JointVelocityArray
# A list of joint names
string[] joint_names

# Velocity for each of the above joints
float64[] velocities

"""
  __slots__ = ['costs','gradient','in_collision']
  _slot_types = ['float64[]','chomp_motion_planner/JointVelocityArray[]','uint8']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   costs,gradient,in_collision
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(GetChompCollisionCostResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.costs is None:
        self.costs = []
      if self.gradient is None:
        self.gradient = []
      if self.in_collision is None:
        self.in_collision = 0
    else:
      self.costs = []
      self.gradient = []
      self.in_collision = 0

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      #serialize self.costs
      length = len(self.costs)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.costs))
      #serialize self.gradient
      length = len(self.gradient)
      buff.write(struct.pack('<I', length))
      for val1 in self.gradient:
        #serialize val1.joint_names
        length = len(val1.joint_names)
        buff.write(struct.pack('<I', length))
        for val2 in val1.joint_names:
          length = len(val2)
          #serialize val2
          buff.write(struct.pack('<I%ss'%length, length, val2))
        #serialize val1.velocities
        length = len(val1.velocities)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.velocities))
      buff.write(struct.pack('<B', self.in_collision))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      #deserialize self.costs
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.costs = struct.unpack(pattern, str[start:end])
      #deserialize self.gradient
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.gradient = []
      for i in xrange(0, length):
        val1 = chomp_motion_planner.msg.JointVelocityArray()
        #deserialize val1.joint_names
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.joint_names = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2,) = struct.unpack(pattern, str[start:end])
          val1.joint_names.append(val2)
        #deserialize val1.velocities
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.velocities = struct.unpack(pattern, str[start:end])
        self.gradient.append(val1)
      start = end
      end += 1
      (self.in_collision,) = struct.unpack('<B',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      #serialize self.costs
      length = len(self.costs)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.costs.tostring())
      #serialize self.gradient
      length = len(self.gradient)
      buff.write(struct.pack('<I', length))
      for val1 in self.gradient:
        #serialize val1.joint_names
        length = len(val1.joint_names)
        buff.write(struct.pack('<I', length))
        for val2 in val1.joint_names:
          length = len(val2)
          #serialize val2
          buff.write(struct.pack('<I%ss'%length, length, val2))
        #serialize val1.velocities
        length = len(val1.velocities)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.velocities.tostring())
      buff.write(struct.pack('<B', self.in_collision))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      #deserialize self.costs
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.costs = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.gradient
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.gradient = []
      for i in xrange(0, length):
        val1 = chomp_motion_planner.msg.JointVelocityArray()
        #deserialize val1.joint_names
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.joint_names = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2,) = struct.unpack(pattern, str[start:end])
          val1.joint_names.append(val2)
        #deserialize val1.velocities
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.velocities = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        self.gradient.append(val1)
      start = end
      end += 1
      (self.in_collision,) = struct.unpack('<B',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

class GetChompCollisionCost(roslib.message.ServiceDefinition):
  _type          = 'chomp_motion_planner/GetChompCollisionCost'
  _md5sum = '918b2ae40ae7d55dee620a11c5ce0d49'
  _request_class  = GetChompCollisionCostRequest
  _response_class = GetChompCollisionCostResponse
