/* auto-generated by gensrv_cpp from /opt/ros/boxturtle/stacks/motion_planners/chomp_motion_planner/srv/GetChompCollisionCost.srv.  Do not edit! */
#ifndef SRV_CHOMP_MOTION_PLANNER_GETCHOMPCOLLISIONCOST_H
#define SRV_CHOMP_MOTION_PLANNER_GETCHOMPCOLLISIONCOST_H

#include <string>
#include <cstring>
#include <vector>
#include <map>
#include "ros/message.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "sensor_msgs/JointState.h"
#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "motion_planning_msgs/MultiDOFJointState.h"
#include "motion_planning_msgs/RobotState.h"

#include "chomp_motion_planner/JointVelocityArray.h"

namespace chomp_motion_planner
{

struct GetChompCollisionCost
{

inline static std::string getDataType() { return "chomp_motion_planner/GetChompCollisionCost"; }
inline static std::string getMD5Sum() { return "918b2ae40ae7d55dee620a11c5ce0d49"; }

//! \htmlinclude Request.msg.html

class Request : public ros::Message
{
public:
  typedef boost::shared_ptr<Request> Ptr;
  typedef boost::shared_ptr<Request const> ConstPtr;

  typedef std::vector<std::string> _links_type;
  typedef motion_planning_msgs::RobotState _state_type;

  std::vector<std::string> links;
  motion_planning_msgs::RobotState state;

  Request() : ros::Message()
  {
  }
  Request(const Request &copy) : ros::Message(),
    state(copy.state)
  {
    (void)copy;
    links = copy.links;
  }
  Request &operator =(const Request &copy)
  {
    if (this == &copy)
      return *this;
    links.clear();
    links = copy.links;
    state = copy.state;
    return *this;
  }
  virtual ~Request() 
  {
    links.clear();
  }
  inline static std::string __s_getDataType() { return std::string("chomp_motion_planner/GetChompCollisionCostRequest"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# Array of string names for the links for which cost information is desired\n"
    "string[] links\n"
    "\n"
    "# The state of the robot represented as an array of Kinematic states which\n"
    "# include the joint name and joint value\n"
    "motion_planning_msgs/RobotState state\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("918b2ae40ae7d55dee620a11c5ce0d49"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("chomp_motion_planner/GetChompCollisionCost"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  void set_links_size(uint32_t __ros_new_size)
  {
    this->links.resize(__ros_new_size);
  }
  inline uint32_t get_links_size() const { return links.size(); }
  uint32_t calc_links_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t links_size = links.size();
    for (size_t i = 0; i < links_size; i++)
      l += 4 + links[i].length();
    return l;
  }
  inline void get_links_vec (std::vector<std::string> &__ros_vec) const
  {
    __ros_vec = this->links;
  }
  inline void set_links_vec(const std::vector<std::string> &__ros_vec)
  {
    this->links = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + calc_links_array_serialization_len(); // links
    __l += state.serializationLength(); // state
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    uint32_t __links_size = links.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __links_size);
    for (size_t i = 0; i < __links_size; i++)
    {
      unsigned __ros_links_i__len = links[i].length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_links_i__len);
    SROS_SERIALIZE_BUFFER(write_ptr, links[i].c_str(), __ros_links_i__len);
    }
    write_ptr = state.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    uint32_t __links_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __links_size);
    set_links_size(__links_size);
    for (size_t i = 0; i < __links_size; i++)
    {
      unsigned __ros_links_i__len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_links_i__len);
    links[i] = std::string((const char *)read_ptr, __ros_links_i__len);
    read_ptr += __ros_links_i__len;
    }
    read_ptr = state.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Request> RequestPtr;
typedef boost::shared_ptr<Request const> RequestConstPtr;

//! \htmlinclude Response.msg.html

class Response : public ros::Message
{
public:
  typedef boost::shared_ptr<Response> Ptr;
  typedef boost::shared_ptr<Response const> ConstPtr;

  typedef std::vector<double> _costs_type;
  typedef std::vector<chomp_motion_planner::JointVelocityArray> _gradient_type;
  typedef uint8_t _in_collision_type;

  std::vector<double> costs;
  std::vector<chomp_motion_planner::JointVelocityArray> gradient;
  uint8_t in_collision;

  Response() : ros::Message(),
    in_collision(0)
  {
  }
  Response(const Response &copy) : ros::Message(),
    in_collision(copy.in_collision)
  {
    (void)copy;
    costs = copy.costs;
    gradient = copy.gradient;
  }
  Response &operator =(const Response &copy)
  {
    if (this == &copy)
      return *this;
    costs.clear();
    gradient.clear();
    costs = copy.costs;
    gradient = copy.gradient;
    in_collision = copy.in_collision;
    return *this;
  }
  virtual ~Response() 
  {
    costs.clear();
    gradient.clear();
  }
  inline static std::string __s_getDataType() { return std::string("chomp_motion_planner/GetChompCollisionCostResponse"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "\n"
    "# Returns an array of costs for the links (in the same order as the input)\n"
    "float64[] costs\n"
    "\n"
    "# Each element of this array is a num_joints x 1 array that represents the\n"
    "# joint velocity that will move the link down the gradient of the distance\n"
    "# field (away from collisions)\n"
    "JointVelocityArray[] gradient\n"
    "\n"
    "# A boolean value which indicates whether the configuration is in collision\n"
    "uint8 in_collision\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/RobotState\n"
    "# This message contains information about the robot state, i.e. the positions of its joints and links\n"
    "sensor_msgs/JointState joint_state\n"
    "motion_planning_msgs/MultiDOFJointState multi_dof_joint_state\n"
    "================================================================================\n"
    "MSG: sensor_msgs/JointState\n"
    "# This is a message that holds data to describe the state of a set of torque controlled joints. \n"
    "#\n"
    "# The state of each joint is defined by:\n"
    "#  * the position of the joint, \n"
    "#  * the velocity of the joint and \n"
    "#  * the effort that is applied in the joint.\n"
    "#\n"
    "# Each joint is uniquely identified by its name\n"
    "# The header specifies the time at which the joint states were recorded. All the joint states\n"
    "# in one message have to be recorded at the same time.\n"
    "#\n"
    "# This message consists of a multiple arrays, one for each part of the joint state. \n"
    "# The goal is to make each of the fields optional. When e.g. your joints have no\n"
    "# effort associated with them, you can leave the effort array empty. \n"
    "#\n"
    "# All arrays in this message should have the same size, or be empty.\n"
    "# This is the only way to uniquely associate the joint name with the correct\n"
    "# states.\n"
    "\n"
    "\n"
    "Header header\n"
    "\n"
    "string[] name\n"
    "float64[] position\n"
    "float64[] velocity\n"
    "float64[] effort\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/MultiDOFJointState\n"
    "#A representation of a multi-dof joint state\n"
    "time stamp\n"
    "string joint_name\n"
    "string frame_id\n"
    "string child_frame_id\n"
    "geometry_msgs/Pose pose\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "================================================================================\n"
    "MSG: chomp_motion_planner/JointVelocityArray\n"
    "# A list of joint names\n"
    "string[] joint_names\n"
    "\n"
    "# Velocity for each of the above joints\n"
    "float64[] velocities\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("918b2ae40ae7d55dee620a11c5ce0d49"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("chomp_motion_planner/GetChompCollisionCost"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  void set_costs_size(uint32_t __ros_new_size)
  {
    this->costs.resize(__ros_new_size);
  }
  inline uint32_t get_costs_size() const { return costs.size(); }
  inline void get_costs_vec (std::vector<double> &__ros_vec) const
  {
    __ros_vec = this->costs;
  }
  inline void set_costs_vec(const std::vector<double> &__ros_vec)
  {
    this->costs = __ros_vec;
  }
  void set_gradient_size(uint32_t __ros_new_size)
  {
    this->gradient.resize(__ros_new_size);
  }
  inline uint32_t get_gradient_size() const { return gradient.size(); }
  uint32_t calc_gradient_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t gradient_size = gradient.size();
    for (size_t i = 0; i < gradient_size; i++)
      l += gradient[i].serializationLength();
    return l;
  }
  inline void get_gradient_vec (std::vector<chomp_motion_planner::JointVelocityArray> &__ros_vec) const
  {
    __ros_vec = this->gradient;
  }
  inline void set_gradient_vec(const std::vector<chomp_motion_planner::JointVelocityArray> &__ros_vec)
  {
    this->gradient = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + (costs.size() ? costs.size() * 8 : 0); // costs
    __l += 4 + calc_gradient_array_serialization_len(); // gradient
    __l += 1; // in_collision
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    uint32_t __costs_size = costs.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __costs_size);
    memcpy(write_ptr, &costs[0], sizeof(double) * __costs_size);
    write_ptr += sizeof(double) * __costs_size;
    uint32_t __gradient_size = gradient.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __gradient_size);
    for (size_t i = 0; i < __gradient_size; i++)
      write_ptr = gradient[i].serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, in_collision);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    uint32_t __costs_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __costs_size);
    set_costs_size(__costs_size);
    memcpy(&costs[0], read_ptr, sizeof(double) * __costs_size);
    read_ptr += sizeof(double) * __costs_size;
    uint32_t __gradient_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __gradient_size);
    set_gradient_size(__gradient_size);
    for (size_t i = 0; i < __gradient_size; i++)
      read_ptr = gradient[i].deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, in_collision);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Response> ResponsePtr;
typedef boost::shared_ptr<Response const> ResponseConstPtr;

Request request;
Response response;

};

}

#endif
