/* auto-generated by gensrv_cpp from /opt/ros/boxturtle/stacks/motion_planners/chomp_motion_planner/srv/GetStateCost.srv.  Do not edit! */
#ifndef SRV_CHOMP_MOTION_PLANNER_GETSTATECOST_H
#define SRV_CHOMP_MOTION_PLANNER_GETSTATECOST_H

#include <string>
#include <cstring>
#include <vector>
#include <map>
#include "ros/message.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "sensor_msgs/JointState.h"
#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "motion_planning_msgs/MultiDOFJointState.h"
#include "motion_planning_msgs/RobotState.h"

namespace chomp_motion_planner
{

struct GetStateCost
{

inline static std::string getDataType() { return "chomp_motion_planner/GetStateCost"; }
inline static std::string getMD5Sum() { return "09647c5461cf8a779f7af1c14b4b7860"; }

//! \htmlinclude Request.msg.html

class Request : public ros::Message
{
public:
  typedef boost::shared_ptr<Request> Ptr;
  typedef boost::shared_ptr<Request const> ConstPtr;

  typedef std::vector<std::string> _link_names_type;
  typedef motion_planning_msgs::RobotState _robot_state_type;

  std::vector<std::string> link_names;
  motion_planning_msgs::RobotState robot_state;

  Request() : ros::Message()
  {
  }
  Request(const Request &copy) : ros::Message(),
    robot_state(copy.robot_state)
  {
    (void)copy;
    link_names = copy.link_names;
  }
  Request &operator =(const Request &copy)
  {
    if (this == &copy)
      return *this;
    link_names.clear();
    link_names = copy.link_names;
    robot_state = copy.robot_state;
    return *this;
  }
  virtual ~Request() 
  {
    link_names.clear();
  }
  inline static std::string __s_getDataType() { return std::string("chomp_motion_planner/GetStateCostRequest"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# A service call to get the cost for a given state of the robot (specified in the form of a RobotState message)\n"
    "\n"
    "# A list of link names for which the cost should be computed\n"
    "string[] link_names\n"
    "# The robot state for which the cost should be computed\n"
    "motion_planning_msgs/RobotState robot_state\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("09647c5461cf8a779f7af1c14b4b7860"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("chomp_motion_planner/GetStateCost"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  void set_link_names_size(uint32_t __ros_new_size)
  {
    this->link_names.resize(__ros_new_size);
  }
  inline uint32_t get_link_names_size() const { return link_names.size(); }
  uint32_t calc_link_names_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t link_names_size = link_names.size();
    for (size_t i = 0; i < link_names_size; i++)
      l += 4 + link_names[i].length();
    return l;
  }
  inline void get_link_names_vec (std::vector<std::string> &__ros_vec) const
  {
    __ros_vec = this->link_names;
  }
  inline void set_link_names_vec(const std::vector<std::string> &__ros_vec)
  {
    this->link_names = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + calc_link_names_array_serialization_len(); // link_names
    __l += robot_state.serializationLength(); // robot_state
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    uint32_t __link_names_size = link_names.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __link_names_size);
    for (size_t i = 0; i < __link_names_size; i++)
    {
      unsigned __ros_link_names_i__len = link_names[i].length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_link_names_i__len);
    SROS_SERIALIZE_BUFFER(write_ptr, link_names[i].c_str(), __ros_link_names_i__len);
    }
    write_ptr = robot_state.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    uint32_t __link_names_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __link_names_size);
    set_link_names_size(__link_names_size);
    for (size_t i = 0; i < __link_names_size; i++)
    {
      unsigned __ros_link_names_i__len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_link_names_i__len);
    link_names[i] = std::string((const char *)read_ptr, __ros_link_names_i__len);
    read_ptr += __ros_link_names_i__len;
    }
    read_ptr = robot_state.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Request> RequestPtr;
typedef boost::shared_ptr<Request const> RequestConstPtr;

//! \htmlinclude Response.msg.html

class Response : public ros::Message
{
public:
  typedef boost::shared_ptr<Response> Ptr;
  typedef boost::shared_ptr<Response const> ConstPtr;

  typedef uint8_t _valid_type;
  typedef std::vector<double> _costs_type;

  uint8_t valid;
  std::vector<double> costs;

  Response() : ros::Message(),
    valid(0)
  {
  }
  Response(const Response &copy) : ros::Message(),
    valid(copy.valid)
  {
    (void)copy;
    costs = copy.costs;
  }
  Response &operator =(const Response &copy)
  {
    if (this == &copy)
      return *this;
    costs.clear();
    valid = copy.valid;
    costs = copy.costs;
    return *this;
  }
  virtual ~Response() 
  {
    costs.clear();
  }
  inline static std::string __s_getDataType() { return std::string("chomp_motion_planner/GetStateCostResponse"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# True if the cost computation was valid\n"
    "bool valid\n"
    "# The cost corresponding to each link\n"
    "float64[] costs\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/RobotState\n"
    "# This message contains information about the robot state, i.e. the positions of its joints and links\n"
    "sensor_msgs/JointState joint_state\n"
    "motion_planning_msgs/MultiDOFJointState multi_dof_joint_state\n"
    "================================================================================\n"
    "MSG: sensor_msgs/JointState\n"
    "# This is a message that holds data to describe the state of a set of torque controlled joints. \n"
    "#\n"
    "# The state of each joint is defined by:\n"
    "#  * the position of the joint, \n"
    "#  * the velocity of the joint and \n"
    "#  * the effort that is applied in the joint.\n"
    "#\n"
    "# Each joint is uniquely identified by its name\n"
    "# The header specifies the time at which the joint states were recorded. All the joint states\n"
    "# in one message have to be recorded at the same time.\n"
    "#\n"
    "# This message consists of a multiple arrays, one for each part of the joint state. \n"
    "# The goal is to make each of the fields optional. When e.g. your joints have no\n"
    "# effort associated with them, you can leave the effort array empty. \n"
    "#\n"
    "# All arrays in this message should have the same size, or be empty.\n"
    "# This is the only way to uniquely associate the joint name with the correct\n"
    "# states.\n"
    "\n"
    "\n"
    "Header header\n"
    "\n"
    "string[] name\n"
    "float64[] position\n"
    "float64[] velocity\n"
    "float64[] effort\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/MultiDOFJointState\n"
    "#A representation of a multi-dof joint state\n"
    "time stamp\n"
    "string joint_name\n"
    "string frame_id\n"
    "string child_frame_id\n"
    "geometry_msgs/Pose pose\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("09647c5461cf8a779f7af1c14b4b7860"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("chomp_motion_planner/GetStateCost"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  void set_costs_size(uint32_t __ros_new_size)
  {
    this->costs.resize(__ros_new_size);
  }
  inline uint32_t get_costs_size() const { return costs.size(); }
  inline void get_costs_vec (std::vector<double> &__ros_vec) const
  {
    __ros_vec = this->costs;
  }
  inline void set_costs_vec(const std::vector<double> &__ros_vec)
  {
    this->costs = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 1; // valid
    __l += 4 + (costs.size() ? costs.size() * 8 : 0); // costs
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    SROS_SERIALIZE_PRIMITIVE(write_ptr, valid);
    uint32_t __costs_size = costs.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __costs_size);
    memcpy(write_ptr, &costs[0], sizeof(double) * __costs_size);
    write_ptr += sizeof(double) * __costs_size;
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, valid);
    uint32_t __costs_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __costs_size);
    set_costs_size(__costs_size);
    memcpy(&costs[0], read_ptr, sizeof(double) * __costs_size);
    read_ptr += sizeof(double) * __costs_size;
    return read_ptr;
  }
};

typedef boost::shared_ptr<Response> ResponsePtr;
typedef boost::shared_ptr<Response const> ResponseConstPtr;

Request request;
Response response;

};

}

#endif
