/*********************************************************************
* Software License Agreement (BSD License)
* 
*  Copyright (c) 2008, Willow Garage, Inc.
*  All rights reserved.
* 
*  Redistribution and use in source and binary forms, with or without
*  modification, are permitted provided that the following conditions
*  are met:
* 
*   * Redistributions of source code must retain the above copyright
*     notice, this list of conditions and the following disclaimer.
*   * Redistributions in binary form must reproduce the above
*     copyright notice, this list of conditions and the following
*     disclaimer in the documentation and/or other materials provided
*     with the distribution.
*   * Neither the name of the Willow Garage nor the names of its
*     contributors may be used to endorse or promote products derived
*     from this software without specific prior written permission.
* 
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
*  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
*  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
*  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
*  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
*  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
*  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
*  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
*  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
*  POSSIBILITY OF SUCH DAMAGE.
*********************************************************************/

/* \author Ioan Sucan */

/** I actually found this macro magic online (forgot where, a forum, I think) */

#ifndef OMPL_DATASTRUCTURES_HASH_
#define OMPL_DATASTRUCTURES_HASH_


#ifdef __GNUC__
// OS X doesn't have features.h.  Instead we'll just paste in the
// definition of __GNUC_PREREQ() taken from a Linux version of features.h.
//#  include <features.h>
#  ifndef __GNUC_PREREQ
#    if defined __GNUC__ && defined __GNUC_MINOR__
#      define __GNUC_PREREQ(maj, min) \
                ((__GNUC__ << 16) + __GNUC_MINOR__ >= ((maj) << 16) + (min))
#    else
#      define __GNUC_PREREQ(maj, min) 0
#    endif
#  endif


#  if __GNUC_PREREQ(4,1)
#    include <tr1/unordered_map>
#    define OMPL_NS_HASH std::tr1
#    define OMPL_NAME_HASH unordered_map
#  elif __GNUC_PREREQ(3,2)
#    include <ext/hash_map>
#    define OMPL_NS_HASH __gnu_cxx
#    define OMPL_NAME_HASH hash_map
#  else
#    error Need to include <hash_map> or equivalent
#  endif

#else
#  ifdef __PGI
#    include <hash_map>
#    define OMPL_NS_HASH _STLP_STD
#    define OMPL_NAME_HASH hash_map
#  elif defined _MSVC
#    include <hash_map>
#    define OMPL_NS_HASH stdext
#    define OMPL_NAME_HASH hash_map
#  else
#    error Need to include <hash_map> or equivalent
#  endif

#endif

#endif
